## ngspetsc 0.0~git20240318.f83b50a

=== Makefile ===
MPI_EXEC = ${PETSC_DIR}/${PETSC_ARCH}/bin/mpiexec
lint:
	pylint --disable=C0412,C0103,C0415,C0321,E0401,E1101,E0611,R1728,R1736,R0401,R0801,R0902,R1702,R0913,R0914,R0903,R0205,R0912,R0915,I1101,W0201,C0209 --variable-naming-style=camelCase --class-naming-style=PascalCase --argument-naming-style=camelCase --attr-naming-style=camelCase ngsPETSc
	pylint --disable=C0412,C0103,C0415,C0321,C3001,E0401,E1101,E0611,R1728,R1736,R0401,R0801,R0902,R1702,R0913,R0914,R0903,R0205,R0912,R0915,I1101,W0201,W0406,W0212,C0209 --variable-naming-style=camelCase --class-naming-style=PascalCase --argument-naming-style=camelCase --attr-naming-style=camelCase ngsPETSc/utils
lint_test:
	pylint --disable=C0412,C0103,C0415,C0321,E0401,E1101,E0611,R1728,R1736,R0401,R0914,R0801,R0902,R1702,R0913,R0903,R0205,R0912,R0915,I1101,W0201,C0209 --variable-naming-style=camelCase --class-naming-style=PascalCase --argument-naming-style=camelCase --attr-naming-style=camelCase tests
test:
	pytest tests/test_env.py
	pytest tests/test_vec.py
	pytest tests/test_mat.py
	pytest tests/test_plex.py
	pytest tests/test_ksp.py
	pytest tests/test_pc.py
	pytest tests/test_eps.py
	pytest tests/test_snes.py
	pytest tests/test_fenicsx.py
test_mpi:
	$(MPI_EXEC) --allow-run-as-root -n 2 pytest --with-mpi tests/test_env.py
	$(MPI_EXEC) --allow-run-as-root -n 2 pytest --with-mpi tests/test_vec.py
	$(MPI_EXEC) --allow-run-as-root -n 2 pytest --with-mpi tests/test_mat.py
	$(MPI_EXEC) --allow-run-as-root -n 2 pytest --with-mpi tests/test_plex.py
	$(MPI_EXEC) --allow-run-as-root -n 2 pytest --with-mpi tests/test_ksp.py
	$(MPI_EXEC) --allow-run-as-root -n 2 pytest --with-mpi tests/test_pc.py
	$(MPI_EXEC) --allow-run-as-root -n 2 pytest --with-mpi tests/test_eps.py
	$(MPI_EXEC) --allow-run-as-root -n 2 pytest --with-mpi tests/test_snes.py
	$(MPI_EXEC) --allow-run-as-root -n 2 pytest --with-mpi tests/test_fenicsx.py
doc:
	rm docs/src/notebooks/*.rst
	jupyter nbconvert --to rst docs/src/notebooks/*.ipynb

push: lint lint_test test test_mpi
	git gui
	git push 

pushf: lint lint_test test test_mpi
	git gui
	git push -f

=== docs/requirements.txt ===
alabaster==0.7.13
astroid==2.15.4
asttokens==2.2.1
attrs==23.1.0
Babel==2.12.1
backcall==0.2.0
beautifulsoup4==4.12.2
bleach==6.0.0
certifi==2023.5.7
charset-normalizer==3.1.0
comm==0.1.3
Cython==0.29.34
debugpy==1.6.7
decorator==5.1.1
defusedxml==0.7.1
dill==0.3.6
docutils==0.18.1
entrypoints==0.4
exceptiongroup==1.1.1
executing==1.2.0
fastjsonschema==2.17.1
idna==3.4
imagesize==1.4.1
iniconfig==2.0.0
ipykernel==6.24.0
ipyparallel==8.6.1
ipython==8.14.0
ipywidgets==8.0.7
isort==5.12.0
jedi==0.18.2
Jinja2==3.1.2
jsonschema==4.18.0
jsonschema-specifications==2023.6.1
jupyter-sphinx
jupyter_client==8.3.0
jupyter_core==5.3.1
jupyterlab-pygments==0.2.2
jupyterlab-widgets==3.0.8
lazy-object-proxy==1.9.0
MarkupSafe==2.1.3
mccabe==0.7.0
mistune==3.0.1
nbclient==0.8.0
nbconvert==7.6.0
nbformat==5.9.0
nbsphinx
nest-asyncio==1.5.6
numpy==1.24.2
packaging==23.1
pandocfilters==1.5.0
parso==0.8.3
pexpect==4.8.0
pickleshare==0.7.5
platformdirs==3.5.0
pluggy==1.0.0
prompt-toolkit==3.0.39
psutil==5.9.5
ptyprocess==0.7.0
pure-eval==0.2.2
Pygments==2.15.1
pylint==2.17.4
pytest==7.3.1
pytest-mpi==0.6
python-dateutil==2.8.2
pyzmq==25.1.0
referencing==0.29.1
requests==2.31.0
rpds-py==0.8.8
scipy==1.11.1
six==1.16.0
snowballstemmer==2.2.0
soupsieve==2.4.1
Sphinx<=6.2.1
sphinx-autodoc-typehints
sphinx-rtd-theme
sphinxcontrib-applehelp
sphinxcontrib-devhelp
sphinxcontrib-htmlhelp
sphinxcontrib-jquery
sphinxcontrib-jsmath
sphinxcontrib-qthelp
sphinxcontrib-serializinghtml
stack-data==0.6.2
tbb==2021.9.0
tinycss2==1.2.1
tomli==2.0.1
tomlkit==0.11.8
tornado==6.3.2
tqdm==4.65.0
traitlets==5.9.0
typing_extensions==4.5.0
urllib3==2.0.3
wcwidth==0.2.6
webencodings==0.5.1
widgetsnbextension==4.0.8
wrapt==1.15.0

=== debian/changelog ===
ngspetsc (0.0~git20240318.f83b50a-3) unstable; urgency=medium

  * complex number tests Depends: python3-dolfinx-complex
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Fri, 31 May 2024 15:42:07 +0200

ngspetsc (0.0~git20240318.f83b50a-2) unstable; urgency=medium

  * drop debian patch revert_ufl_mesh_PR15.patch
    since dolfinx 0.8 is now available.
    Build-Depends: fenicsx (>= 2:0.8~)

 -- Drew Parsons <dparsons@debian.org>  Sat, 11 May 2024 11:31:08 +0200

ngspetsc (0.0~git20240318.f83b50a-1) unstable; urgency=medium

  * New upstream snapshot

 -- Drew Parsons <dparsons@debian.org>  Fri, 22 Mar 2024 00:38:09 +0100

ngspetsc (0.0~git20240130.0c8a05b-2) unstable; urgency=medium

  [ Francesco Ballarin ]
  * Fill debian/upstream/metadata 

 -- Drew Parsons <dparsons@debian.org>  Tue, 20 Feb 2024 12:37:45 +0100

ngspetsc (0.0~git20240130.0c8a05b-1) unstable; urgency=medium

  * Initial release. (Closes: #1063352)
  * Build-Depends: python3 not python3-all since netgen currently only
    builds for the default python.
  * add debian patches
    - test_no_ngsolve.patch skips ngsolve tests
      since ngsolve is not (yet) packaged for debian
      (for now use ngspetsc with fenicsx, or install ngsolve manually)
    - revert_ufl_mesh_PR15.patch reverts upstream PR#15 to work with
       dolfinx 0.7 (ufl 2023.2.0)
    - docs_build.patch removes jupyter-sphinx, which creates references
      to thebelab.css but does not install or link it
  * use debian/py3dist-overrides to define petsc4py dependency
    python3-petsc4py | python3-petsc4py-real | python3-petsc4py-complex
    Note fenicsx utilities work with the complex build of PETSc,
    though ngsolve utilities do not, see upstream Issue#17.
    (ngsolve is not yet packaged for debian)
  * Recommends: python3-slepc4py | python3-slepc4py-real |
    python3-slepc4py-complex.
  * Depends: python3-netgen
  * Build-Depends: libpetsc-real-dev as Recommended by python3-petsc4py
    (Recommends are not installed by default in buildd chroots).
    Needed to set the default PETSC_DIR path /usr/lib/petsc.
    Also for debian/tests (testing libpetsc-complex-dev as well).
  * set pytest, pylint dependencies to nothing in py3dist-overrides
    (they are listed in install_requires rather than setup_requires)

 -- Drew Parsons <dparsons@debian.org>  Wed, 07 Feb 2024 19:14:48 +0100

=== debian/control ===
Source: ngspetsc
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>,
 Francesco Ballarin <francesco.ballarin@unicatt.it>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 fenicsx (>= 2:0.8~),
 libpetsc-real-dev,
 pybuild-plugin-pyproject,
 python3-setuptools,
 python3,
 python3-petsc4py,
 python3-mpi4py,
 python3-netgen,
 python3-numpy,
 python3-pytest <!nocheck>,
 python3-sphinx,
 python3-sphinx-autodoc-typehints <!nodoc>,
 pandoc <!nodoc>,
 python3-ipython <!nodoc>,
 python3-nbsphinx <!nodoc>,
 python3-sphinx-rtd-theme <!nodoc>
#Testsuite: autopkgtest-pkg-python
Standards-Version: 4.7.0
Homepage: https://github.com/NGSolve/ngsPETSc
Vcs-Browser: https://salsa.debian.org/science-team/ngsPETSc
Vcs-Git: https://salsa.debian.org/science-team/ngsPETSc.git

Package: python3-ngspetsc
Architecture: all
Multi-Arch: foreign
Depends:
 python3-netgen,
 python3-numpy,
 ${python3:Depends},
 ${misc:Depends},
Recommends:
 python3-slepc4py | python3-slepc4py-real | python3-slepc4py-complex,
Suggests:
 python-ngspetsc-doc,
 fenicsx (>= 2:0.8~)
Description: a PETSc interface for NGSolve (Python 3)
 ngsPETSc is a PETSc interface for NGSolve. It extends the utility of
 meshes generated by netgen and interfaces with finite element solvers
 such as dolfinx (fenicsx) as well as NGSolve, Firedrake.
 .
 This package installs the library for Python 3.

Package: python-ngspetsc-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${sphinxdoc:Depends},
 ${misc:Depends},
Description: a PETSc interface for NGSolve (docs)
 ngsPETSc is a PETSc interface for NGSolve. It extends the utility of
 meshes generated by netgen and interfaces with finite element solvers
 such as dolfinx (fenicsx) as well as NGSolve, Firedrake.
 .
 This is the documentation package.

=== debian/tests/control ===
Test-Command: pytest-3 -v
Depends: python3-ngspetsc,
 libpetsc-real-dev,
 fenicsx (>= 2:0.8~),
 python3-pytest

Test-Command: PETSC_DIR=/usr/lib/petscdir/petsc-complex SLEPC_DIR=/usr/lib/slepcdir/slepc-complex pytest-3 -v
Depends: python3-ngspetsc,
 python3-petsc4py-complex,
 libpetsc-complex-dev,
 fenicsx (>= 2:0.8~),
 python3-dolfinx-complex (>= 1:0.8~),
 python3-pytest

=== debian/watch ===
version=4
opts="mode=git,pretty=0.0~git%cd.%h" \
 https://github.com/NGSolve/ngsPETSc.git HEAD

## ngspetsc 0.0~git20241016.a196ed4

=== debian/changelog ===
ngspetsc (0.0~git20241016.a196ed4-1) unstable; urgency=medium

  * New upstream snapshot
  * Squash trailing white space in previous changelog entry
  * Standards-Version: 4.7.0
  * Remove revert_ufl_mesh_PR15.patch, since reversing that change was only
    needed to support dolfinx 0.7. We are now at dolfinx 0.9, and thus the
    change in upstream PR #15 is currently needed.
  * Remove docs_build.patch since it has been integrated upstream
  * Add patch drop_sphinxcontrib_video.patch to drop documentation dependency on
    sphinxcontrib-video, which is currently not packaged by Debian
  * Add Build-Depends on python3-sphinx-autoapi, which is now required to build
    the documentation

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 03 Nov 2024 15:50:16 +0000

=== debian/control ===
--- 
+++ 
@@ -19,6 +19,7 @@
  python3-numpy,
  python3-pytest <!nocheck>,
  python3-sphinx,
+ python3-sphinx-autoapi <!nodoc>,
  python3-sphinx-autodoc-typehints <!nodoc>,
  pandoc <!nodoc>,
  python3-ipython <!nodoc>,

## ngspetsc 0.0.8

=== debian/changelog ===
ngspetsc (0.0.8-3) unstable; urgency=medium

  * Add 0cc7e30e8a04e8b625671e2b3704ce9a4158b3c7.patch to include upstream PR
    #72 which fixes FTBFS with poetry 2. Closes: #1094126.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Mon, 03 Feb 2025 06:41:25 +0000

ngspetsc (0.0.8-2) unstable; urgency=medium

  * Build-Depends: python3-dolfinx rather than fenicsx
    to work around Bug#1088865 blocking fenics.

 -- Drew Parsons <dparsons@debian.org>  Mon, 30 Dec 2024 10:42:53 +0100

ngspetsc (0.0.8-1) unstable; urgency=medium

  * New upstream release

 -- Drew Parsons <dparsons@debian.org>  Sat, 14 Dec 2024 14:47:11 +0100

ngspetsc (0.0.7~a8-1) unstable; urgency=medium

  * New upstream alpha release
    - Build-Depends: python3-poetry-core
  * update debian/watch to a github release pattern
    - include uversionmangle for upstream's alpha releases

 -- Drew Parsons <dparsons@debian.org>  Sat, 23 Nov 2024 11:57:46 +0100

ngspetsc (0.0~git20241103.14a66d7-1) unstable; urgency=medium

  * New upstream snapshot
  * Add Build-Depends-Indep: libjs-mathjax and doc_local_mathjax.patch to use
    local mathjax when building the documentation
  * Add Build-Depends-Indep: libjs-requirejs

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Wed, 06 Nov 2024 09:40:49 +0000

=== debian/control ===
--- 
+++ 
@@ -8,12 +8,13 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-sequence-python3,
- fenicsx (>= 2:0.8~),
  libpetsc-real-dev,
  pybuild-plugin-pyproject,
  python3-setuptools,
  python3,
+ python3-dolfinx,
  python3-petsc4py,
+ python3-poetry-core,
  python3-mpi4py,
  python3-netgen,
  python3-numpy,
@@ -25,6 +26,9 @@
  python3-ipython <!nodoc>,
  python3-nbsphinx <!nodoc>,
  python3-sphinx-rtd-theme <!nodoc>
+Build-Depends-Indep:
+ libjs-mathjax,
+ libjs-requirejs
 #Testsuite: autopkgtest-pkg-python
 Standards-Version: 4.7.0
 Homepage: https://github.com/NGSolve/ngsPETSc

## ngspetsc 0.1.0

=== debian/changelog ===
ngspetsc (0.1.0-2) unstable; urgency=medium

  * upload to unstable.
    ngsPETSC is new, so it won't hurt existing stable users.
    Make the first version in stable (trixie) as recent as possible.

 -- Drew Parsons <dparsons@debian.org>  Sat, 31 May 2025 17:47:51 +0200

ngspetsc (0.1.0-1exp1) experimental; urgency=medium

  * New upstream release
    - applies debian patch 0cc7e30...patch
    - versioned Build-Depends: python3-petsc4py (>= 3.22.1~),
      python3-netgen (>= 6.2~)
  * Build-Depends: python3-dolfinx-real <!nocheck>
    for build-time tests, otherwise python3-dolfinx might be satisfied
    by python3-dolfinx-complex

 -- Drew Parsons <dparsons@debian.org>  Fri, 30 May 2025 12:30:17 +0200

=== debian/control ===
--- 
+++ 
@@ -13,10 +13,11 @@
  python3-setuptools,
  python3,
  python3-dolfinx,
- python3-petsc4py,
+ python3-dolfinx-real <!nocheck>,
+ python3-petsc4py (>= 3.22.1~),
  python3-poetry-core,
  python3-mpi4py,
- python3-netgen,
+ python3-netgen (>= 6.2~),
  python3-numpy,
  python3-pytest <!nocheck>,
  python3-sphinx,

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export PYBUILD_NAME=ngspetsc

# ngsolve itself is not yet packaged
# for debian, only run fenicsx tests
export PYBUILD_TEST_ARGS=-v -k test_fenicsx

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

execute_after_dh_auto_build-indep: export http_proxy=127.0.0.1:9
execute_after_dh_auto_build-indep: export https_proxy=127.0.0.1:9
execute_after_dh_auto_build-indep:
	PYTHONPATH=. make html -C docs BUILDDIR=$(CURDIR)/.pybuild/docs

## ngspetsc 0.1.1

=== Makefile ===
MPI_EXEC = ${PETSC_DIR}/${PETSC_ARCH}/bin/mpiexec
GITHUB_ACTIONS_FORMATTING=0

ifeq ($(GITHUB_ACTIONS_FORMATTING), 1)
	PYLINT_FORMAT=--msg-template='::error file={path},line={line},col={column},title={msg_id}::{path}:{line}:{column}: {msg_id} {msg}'
else
	PYLINT_FORMAT=
endif

lint:
	pylint ${PYLINT_FORMAT} --disable=C0412,C0103,C0415,C0321,C3001,E0401,E1101,E0611,R1728,R1736,R0401,R0801,R0902,R1702,R0913,R0914,R0903,R0205,R0912,R0915,R0917,I1101,W0102,W0201,W0212,W0406,C0209 --variable-naming-style=camelCase --class-naming-style=PascalCase --argument-naming-style=camelCase --attr-naming-style=camelCase ngsPETSc
	pylint ${PYLINT_FORMAT} --disable=C0412,C0103,C0415,C0321,C3001,E0401,E1101,E0611,R1728,R1736,R0401,R0801,R0902,R1702,R0913,R0914,R0903,R0205,R0912,R0915,R0917,I1101,W0102,W0201,W0212,W0406,C0209 --variable-naming-style=camelCase --class-naming-style=PascalCase --argument-naming-style=camelCase --attr-naming-style=camelCase ngsPETSc/utils

lint_test:
	pylint ${PYLINT_FORMAT} --disable=C0412,C0103,C0415,C0321,E0401,E1101,E0611,R1728,R1736,R0401,R0914,R0801,R0902,R1702,R0913,R0903,R0205,R0912,R0915,I1101,W0201,C0209 --variable-naming-style=camelCase --class-naming-style=PascalCase --argument-naming-style=camelCase --attr-naming-style=camelCase tests

test:
	pytest tests

test_mpi:
	$(MPI_EXEC) --allow-run-as-root -n 2 pytest --with-mpi tests

doc:
	rm docs/src/notebooks/*.rst
	jupyter nbconvert --to rst docs/src/notebooks/*.ipynb

push: lint lint_test test test_mpi
	git gui
	git push

pushf: lint lint_test test test_mpi
	git gui
	git push -f

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?=
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = src
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== docs/requirements.txt ===
--- 
+++ 
@@ -80,6 +80,8 @@
 sphinxcontrib-jsmath
 sphinxcontrib-qthelp
 sphinxcontrib-serializinghtml
+sphinx-autoapi
+sphinxcontrib-video
 stack-data==0.6.2
 tbb==2021.9.0
 tinycss2==1.2.1

=== debian/changelog ===
ngspetsc (0.1.1-5) unstable; urgency=medium

  * debian/tests: skip test_mixed[partitioner*] on i386

 -- Drew Parsons <dparsons@debian.org>  Fri, 26 Dec 2025 16:55:14 +1000

ngspetsc (0.1.1-4) unstable; urgency=medium

  * debian/tests: run tests with default python3 only, not python3-all,
    since netgen only builds for the default python
  * update debian patch test_mixed_partitioner.patch to provide a
    ghost mode (shared_facet). cf. dolfinx PR#4003.
  * debian/rules: after dh_auto_test delete mixed_mesh.vtkhdf left
    behind by tests in pybuild's build dir

 -- Drew Parsons <dparsons@debian.org>  Tue, 23 Dec 2025 18:12:31 +0000

ngspetsc (0.1.1-3) unstable; urgency=medium

  * debian patch test_mixed_partitioner.patch checks if
    partitioner_kahip is available before running test_mixed()
    (since KAHIP support is optional in dolfinx).
    Also extends test to partitioner_scotch and default partitioner.

 -- Drew Parsons <dparsons@debian.org>  Thu, 13 Nov 2025 15:41:07 +0100

ngspetsc (0.1.1-2) unstable; urgency=medium

  * update debian/tests
    - Depends: python3-all
      and test all supported python versions.
      debian/source/lintian-overrides overrides
      test-leaves-python-version-untested for test-ngpetsc-complex
      since it calls test-ngpetsc, which uses py3versions -s.
    - skip failing tests on i386
      test_markers[2] test_markers[3]
      test_refine[2] test_refine[3]
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Sun, 26 Oct 2025 01:59:28 +0200

ngspetsc (0.1.1-1) unstable; urgency=medium

  * New upstream release

 -- Drew Parsons <dparsons@debian.org>  Fri, 24 Oct 2025 15:11:55 +0200

=== debian/rules ===
--- 
+++ 
@@ -17,3 +17,6 @@
 execute_after_dh_auto_build-indep: export https_proxy=127.0.0.1:9
 execute_after_dh_auto_build-indep:
 	PYTHONPATH=. make html -C docs BUILDDIR=$(CURDIR)/.pybuild/docs
+
+execute_after_dh_auto_test:
+	rm -rf $(CURDIR)/.pybuild/cpython3_*_ngspetsc/build/mixed_mesh.vtkhdf

=== debian/tests/control ===
Tests: test-ngpetsc
Depends: python3-ngspetsc,
 libpetsc-real-dev,
 python3-dolfinx,
 python3-pytest,
 python3

Tests: test-ngpetsc-complex
Depends: python3-ngspetsc,
 python3-petsc4py-complex,
 libpetsc-complex-dev,
 python3-dolfinx,
 python3-dolfinx-complex (>= 1:0.8~),
 python3-pytest,
 python3
